package com.gjz.eduorder.service.impl;

import com.gjz.commonutils.ordervo.CourseWebVoOrder;
import com.gjz.commonutils.ordervo.UcenterMemberOrder;
import com.gjz.eduorder.client.EduClient;
import com.gjz.eduorder.client.UcenterClient;
import com.gjz.eduorder.entity.Order;
import com.gjz.eduorder.mapper.OrderMapper;
import com.gjz.eduorder.service.OrderService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gjz.eduorder.utils.OrderNoUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 订单 服务实现类
 * </p>
 *
 * @author testjava
 * @since 2022-12-26
 */
@Service
public class OrderServiceImpl extends ServiceImpl<OrderMapper, Order> implements OrderService {

    @Autowired
    private EduClient eduClient;
    @Autowired
    private UcenterClient ucenterClient;
    //接口一 生成订单
    @Override
    public String createOrders(String courseId, String memberId) {
        //通过远程调用获取用户信息
        UcenterMemberOrder userInfoOrder = ucenterClient.getUserInfoOrder(memberId);
        //通过远程调用获取课程休息
        CourseWebVoOrder courseInfoOrder = eduClient.getCourseInfoOrder(courseId);
        //创建order对象，向order对象里设置需要数据
        Order order = new Order();

        order.setOrderNo(OrderNoUtil.getOrderNo());//订单号
        order.setCourseId(courseId);//课程id
        order.setCourseTitle(courseInfoOrder.getTitle());//标题
        order.setCourseCover(courseInfoOrder.getCover());
        order.setTeacherName(courseInfoOrder.getTeacherName());
        order.setTotalFee(courseInfoOrder.getPrice());
        order.setMemberId(memberId);
        order.setMobile(userInfoOrder.getMobile());
        order.setNickname(userInfoOrder.getNickname());

        order.setStatus(0);//支付状态(0未支付 1已支付)
        order.setPayType(1);//支付类型 微信1
        baseMapper.insert(order);
        return order.getOrderNo();

    }
}
